#include <algorithm>
#include <climits>
#include <cstdlib>
#include <cstring>
#include <cstdio>
#include <vector>

#define MAX_NUM_STAT (1000)
#define MAX_LEN_LINE (500)
#define MAX_DIM_ALPH (36)

struct t_move { int h, s; };

static t_move MOVE[MAX_DIM_ALPH][MAX_NUM_STAT];
static bool USED[MAX_LEN_LINE][MAX_NUM_STAT];
static char LINE[MAX_LEN_LINE + 2];
static char HASH[256];

static int max, num, len;

int get_path(int p, int s) {

	for (int i = 0; i < len; ++ i) for (int j = 0; j < max; ++ j) USED[i][j] = 0;
	int l = 0;
	while (!USED[p][s]) {
		int c = LINE[p], p1 = (p + MOVE[c][s].h) % len, s1 = MOVE[c][s].s;
		USED[p][s] = 1; p = p1; s = s1;
		if (s < 0) break;
		++ l;
	}
	return l;
}

#define ERR_OK (0)
#define ERR_WA (1)
#define ERR_PE (2)
#define ERR_UH (3)

int main(int argc, char *argv[]) {
	//...
	for (int i = 'a'; i <= 'z'; ++ i) HASH[i] = (i - 'a') + 10;
	for (int i = '0'; i <= '9'; ++ i) HASH[i] = (i - '0');
	//...
	for (int i = 0; i < MAX_DIM_ALPH; ++ i)
	for (int j = 0; j < MAX_NUM_STAT; ++ j) MOVE[i][j].s = - 1;
	//...
	FILE *fid = fopen(argv[1], "rt");
	fscanf(fid, "%s", LINE);
	len = strlen(LINE);
	for (int i = 0; i < len; ++ i) LINE[i] = HASH[LINE[i]];
	fscanf(fid, "%i", &num);
	max = 0;
	for (int i = 0; i < num; ++ i) {
		char c; int s1, s2, t;
		fscanf(fid, "%i %c %i %i", &s1, &c, &s2, &t);
		max = std::max(max, std::max(s1, s2));
		c = HASH[c];
		MOVE[c][s1].s = s2; MOVE[c][s1].h = t + len;	//NOTE: Чтобы избежать отрицательных значений!
	}
	fclose(fid);
	++ max;
	//...
	int p1, s1, p2, s2;
	//...
	fid = fopen(argv[3], "rt"); fscanf(fid, "%i %i", &p1, &s1);
	fclose(fid);
	//...
	if ((fid = fopen(argv[2], "rt")) == NULL) {
		printf("Output file not found!\n");
		return ERR_PE;
	}
	if (fscanf(fid, "%i %i", &p2, &s2) != 2) {
		printf("Incorrect format!\n");
		return ERR_PE;
	}
	fclose(fid);
	//...
	if ((p2 < 0) || (p2 >= len)) {
		printf("Incorrect position: %i not in [0, %i]\n", p2, len - 1);
		return ERR_WA;
	}
	if ((s2 < 0) || (s2 >= max)) {
		printf("Incorrect state: %i not in [0, %i]\n", s2, max - 1);
		return ERR_WA;
	}
	int n1 = get_path(p1, s1);
	int n2 = get_path(p2, s2);
	if (n1 > n2) {
		//printf("Answer of contestant is not optimal!\n");
		printf("len: %i > %i\n", n1, n2);
		return ERR_WA;
	}
	if (n1 < n2) {
		//printf("Answer of jury is not optimal!\n");
		printf("len: %i < %i\n", n1, n2);
		return ERR_UH;
	}
	printf("len: %i\n", n1);
	//...
	return ERR_OK;
}
