#include <iostream>
#include <fstream>
#include <cstdlib>
#include <string>
#include <tuple>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

#define INV(val, len) ((val) + (((val) > 0)? (-1): (+1)) * len)

static char ALPH[] = "abcdefghijklmopqrstuvwxyz0123456789";

#define ALPH_SIZE (sizeof(ALPH) - 1)

int main(int argc, char *argv[]) {
	//...
	int len = atol(argv[1]), num_stat = atol(argv[2]), num_move = atol(argv[3]), tid = atoi(argv[4]); srand(atoi(argv[5]));
	//...
	std::vector<std::tuple<int, int, int, int> > MOV; std::string str;
	for (int i = 0; i < len; ++ i) str += ALPH[rand() % ALPH_SIZE];
	//...
	//Создаем последовательный путь в графе:
	for (int s = 1, h = 1, p = 0, t = 0; (t < num_stat - 1) && (MOV.size() < num_move); ++ t) {
		if (s + h >= len) h = - 1; else if (s + h <= 0) h = + 1;
		int z = s * (2 * (t % 2) - 1);
		MOV.push_back(std::make_tuple(t, p, t + 1, z));
		p = (p + z + len) % len;
		s += h;
	}
	num_move = MOV.size();
	int p1 = std::get<1> (MOV.back()), s1 = std::get<0> (MOV.back());
	int p2, s2;
	switch (tid) {
	case 1:	//Замыкаем петлю:
		p2 = std::get<1> (MOV[num_move / 2]);
		s2 = std::get<0> (MOV[num_move / 2]);
		std::get<2> (MOV.back()) = s2;
		p2 = INV(p2 - p1, len);
		std::get<3> (MOV.back()) = p2;
		break;
	case 2:	//Замыкаем цикл:
		p2 = std::get<1> (MOV.front());
		s2 = std::get<0> (MOV.front());
		std::get<2> (MOV.back()) = s2;
		p2 = INV(p2 - p1, len);
		std::get<3> (MOV.back()) = p2;
		break;
	}
	//...
	std::string tmp = str;
	std::rotate(str.begin(), str.begin() + rand() % len, str.end());
	//...
	std::vector<int> STT;
	for (int i = 0; i < num_stat; ++ i) STT.push_back(i);
	std::random_shuffle(STT.begin(), STT.end());
	std::random_shuffle(MOV.begin(), MOV.end());
	std::ofstream fid("input.txt");
	fid << str << "\n" << MOV.size() << "\n";
	for (auto &it: MOV) {
		int t1 = STT[std::get<0> (it)];
		int t2 = STT[std::get<2> (it)];
		int p1 = std::get<1> (it);
		int s = std::get<3> (it);
		fid << t1 << " " << tmp[p1];
		fid << " ";
		fid << t2 << " " << s;
		fid << "\n";
	}
	//...
	return 0;
}
