#include <iostream>
#include <fstream>
#include <cstdlib>
#include <string>
#include <tuple>
#include <algorithm>
#include <vector>
#include <set>

static char ALPH[] = "abcdefghijklmopqrstuvwxyz0123456789";

#define ALPH_SIZE (sizeof(ALPH) - 1)

int main(int argc, char *argv[]) {
	//...
	int len = atol(argv[1]), num_stat = atol(argv[2]), num_move = atol(argv[3]), tid = atol(argv[4]); srand(atoi(argv[5]));
	//...
	std::vector<std::tuple<int, int, int, int> > MOV; std::vector<int> IND, KEY; std::string str;
	for (int i = 0; i < len; ++ i) { IND.push_back(i); }
	std::random_shuffle(IND.begin(), IND.end()); std::random_shuffle(ALPH, ALPH + ALPH_SIZE);
	int mid = ALPH_SIZE / 2;
	for (int i = 0; i < ALPH_SIZE; ++ i) KEY.push_back(IND[i]);
	for (int i = 0; i < len; ++ i) {
		str += ALPH[mid + rand() % (ALPH_SIZE - mid)];
	}
	for (int i = 0; i < ALPH_SIZE; ++ i) {
		str[KEY[i]] = ALPH[i];
	}
	//Создаем последовательный путь в графе:
	for (int c = rand() % mid, t = 0; (t < num_stat) && (MOV.size() < num_move); ++ t) {
		int s = 1 - 2 * (t % 2);
		for (int k = 1; k < ALPH_SIZE; ++ k) {
			if (MOV.size() < num_move) {
				MOV.push_back(
					std::make_tuple(t, (c + k) % ALPH_SIZE, t, s)
				);
			}
		}
		if ((t < num_stat - 1) && (MOV.size() < num_move)) {
			MOV.push_back(
				std::make_tuple(t, c, t + 1, - s)
			);
		}
	}
	num_move = MOV.size();
	switch (tid) {
		case 1: {	//Замыкаем петлю:
			int p2 = KEY[std::get<1> (MOV[num_move / 2])];
			int s2 = std::get<0> (MOV[num_move / 2]);
			int p1 = KEY[std::get<1> (MOV.back())];
			int s1 = std::get<0> (MOV.back());
			std::get<2> (MOV.back()) = s2;
			std::get<3> (MOV.back()) = p2 - p1;
			break;
		}
		case 2: {	//Замыкаем цикл:
			int p2 = KEY[std::get<1> (MOV.front())];
			int s2 = std::get<0> (MOV.front());
			int p1 = KEY[std::get<1> (MOV.back())];
			int s1 = std::get<0> (MOV.back());
			std::get<2> (MOV.back()) = s2;
			std::get<3> (MOV.back()) = p2 - p1;
			break;
		}
	}
	//...
	std::vector<int> STT; num_stat = std::min(num_stat, num_move);
	for (int i = 0; i < num_stat; ++ i) STT.push_back(i);
	std::random_shuffle(STT.begin(), STT.end());
	std::random_shuffle(MOV.begin(), MOV.end());
	std::ofstream fid("input.txt");
	fid << str << "\n" << MOV.size() << "\n";
	for (auto &it: MOV) {
		int t1 = STT[std::get<0> (it)];
		int t2 = STT[std::get<2> (it)];
		int c = ALPH[std::get<1> (it)];
		int s = std::get<3> (it);
		fid << t1 << " " << (char) c;
		fid << " ";
		fid << t2 << " " << s;
		fid << "\n";
	}
	//...
	return 0;
}
