#include <algorithm>
#include <climits>
#include <cstdlib>
#include <cstring>
#include <cstdio>
#include <vector>

#define MAX_NUM_STAT (1000)
#define MAX_LEN_LINE (500)
#define MAX_DIM_ALPH (36)

struct t_item { int i, s, f, p; };

static t_item ITEM[MAX_LEN_LINE][MAX_NUM_STAT]; static std::vector<t_item *> PATH;

struct t_move { int h, s; };

static t_move MOVE[MAX_DIM_ALPH][MAX_NUM_STAT];
static char LINE[MAX_LEN_LINE + 2];
static char HASH[256];

static int max, num, len;

int main() {
	//...
	for (int i = 'a'; i <= 'z'; ++ i) HASH[i] = (i - 'a') + 10;
	for (int i = '0'; i <= '9'; ++ i) HASH[i] = (i - '0');
	//...
	for (int i = 0; i < MAX_DIM_ALPH; ++ i)
	for (int j = 0; j < MAX_NUM_STAT; ++ j) MOVE[i][j].s = - 1;
	//...
	FILE *fid = fopen("input.txt", "rt");
	fscanf(fid, "%s", LINE);
	len = strlen(LINE);
	for (int i = 0; i < len; ++ i) LINE[i] = HASH[LINE[i]];
	fscanf(fid, "%i", &num);
	max = 0;
	for (int i = 0; i < num; ++ i) {
		char c; int s1, s2, t;
		fscanf(fid, "%i %c %i %i", &s1, &c, &s2, &t);
		max = std::max(max, std::max(s1, s2));
		c = HASH[c];
		MOVE[c][s1].s = s2; MOVE[c][s1].h = t + len;	//NOTE: Чтобы избежать отрицательных значений!
	}
	fclose(fid);
	++ max;
	//...
	//Основная динамика:
	PATH.reserve(len * max);
	for (int i = 0; i < len; ++ i) for (int s = 0; s < max; ++ s) {
		if (ITEM[i][s].f == 2) continue;
		int c, i1 = i, s1 = s, i2, s2;
		int t, l = 0, p = 0;
		while (true) {
			if (ITEM[i1][s1].f == 1) {
				t = ITEM[i1][s1].p, l = p - t + 1;
				//Пробегаем цикл:
				while (PATH.back()->p != t) {
					PATH.back()->p = l;
					PATH.back()->f = 2;
					PATH.pop_back();
				}
				break;
			}
			if (ITEM[i1][s1].f == 2) {
				l = ITEM[i1][s1].p + 1;
				break;
			}
			PATH.push_back(&ITEM[i1][s1]);
			ITEM[i1][s1].p = ++ p;
			ITEM[i1][s1].f = 1;
			c = LINE[i1];
			i1 = (i1 + MOVE[c][s1].h) % len;
			s1 = MOVE[c][s1].s;
			if (s1 < 0) {
				l = 0;
				break;
			}
		}
		//Пробегаем ветвь:
		while (PATH.size()) {
			PATH.back()->p = l ++;
			PATH.back()->f = 2;
			PATH.pop_back();
		}
	}
	//Получаем ответ:
	int i0 = 0, s0 = 0, l0 = ITEM[i0][s0].p;
	for (int i = 0; i < len; ++ i)
	for (int s = 0; s < max; ++ s) {
		if (ITEM[i][s].p < l0) continue;
		l0 = ITEM[i][s].p;
		i0 = i;
		s0 = s;
	}
	//...
	fid = fopen("output.txt", "wt");
	fprintf(fid, "%i %i", i0, s0);
	fclose(fid);
	//...
	return 0;
}
